"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("..");
var output_1 = require("./output");
var fs_1 = require("fs");
function verify(filesOrGlobPatterns, fix, format, noColor, problemOnly) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, filesOrGlobPatterns_1, filesOrGlobPattern, reports, _loop_1, _a, reports_1, report, reports, _b, reports_2, result;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _i = 0, filesOrGlobPatterns_1 = filesOrGlobPatterns;
                    _c.label = 1;
                case 1:
                    if (!(_i < filesOrGlobPatterns_1.length)) return [3 /*break*/, 9];
                    filesOrGlobPattern = filesOrGlobPatterns_1[_i];
                    if (!fix) return [3 /*break*/, 3];
                    return [4 /*yield*/, __1.exec({
                            files: filesOrGlobPattern,
                            fix: true,
                            rulesAutoResolve: true,
                        })];
                case 2:
                    reports = _c.sent();
                    _loop_1 = function (report) {
                        fs_1.writeFile(report.filePath, report.fixedCode, { encoding: 'utf8' }, function (err) {
                            if (err) {
                                throw err;
                            }
                            process.stdout.write("markuplint: Fix \"" + report.filePath + "\"\n");
                        });
                    };
                    for (_a = 0, reports_1 = reports; _a < reports_1.length; _a++) {
                        report = reports_1[_a];
                        _loop_1(report);
                    }
                    return [3 /*break*/, 8];
                case 3: return [4 /*yield*/, __1.exec({
                        files: filesOrGlobPattern,
                        rulesAutoResolve: true,
                    })];
                case 4:
                    reports = _c.sent();
                    _b = 0, reports_2 = reports;
                    _c.label = 5;
                case 5:
                    if (!(_b < reports_2.length)) return [3 /*break*/, 8];
                    result = reports_2[_b];
                    return [4 /*yield*/, output_1.output(result.filePath, result.results, result.sourceCode, format, noColor, problemOnly)];
                case 6:
                    _c.sent();
                    _c.label = 7;
                case 7:
                    _b++;
                    return [3 /*break*/, 5];
                case 8:
                    _i++;
                    return [3 /*break*/, 1];
                case 9: return [2 /*return*/];
            }
        });
    });
}
exports.verify = verify;
