"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_color_1 = __importDefault(require("cli-color"));
// @ts-ignore
var eastasianwidth_1 = __importDefault(require("eastasianwidth"));
var path_1 = __importDefault(require("path"));
var strip_ansi_1 = __importDefault(require("strip-ansi"));
var url_1 = __importDefault(require("url"));
var eaw = eastasianwidth_1.default;
var defaultConfig = {
    color: true,
    problemOnly: false,
    noStdOut: false,
};
var loggerError = cli_color_1.default.red;
var loggerWarning = cli_color_1.default.xterm(208);
var markuplint = "markup" + cli_color_1.default.xterm(39)('lint');
function standardReporter(targetPath, results, rawSource, options) {
    return __awaiter(this, void 0, void 0, function () {
        var config, sizes, _i, results_1, result, out, lines, _a, results_2, result, prev, line, next, before, after, logger, outs;
        return __generator(this, function (_b) {
            config = Object.assign({}, defaultConfig, options);
            if (!url_1.default.parse(targetPath).host) {
                targetPath = path_1.default.resolve(targetPath);
            }
            sizes = {
                line: 0,
                col: 0,
                meg: 0,
            };
            for (_i = 0, results_1 = results; _i < results_1.length; _i++) {
                result = results_1[_i];
                sizes.line = Math.max(sizes.line, result.line.toString(10).length);
                sizes.col = Math.max(sizes.col, result.col.toString(10).length);
                sizes.meg = Math.max(sizes.meg, w(result.message));
            }
            out = [];
            if (results.length) {
                lines = rawSource.split(/\r?\n/g);
                for (_a = 0, results_2 = results; _a < results_2.length; _a++) {
                    result = results_2[_a];
                    prev = lines[result.line - 2] || '';
                    line = lines[result.line - 1] || '';
                    next = lines[result.line - 0] || '';
                    before = line.substring(0, result.col - 1);
                    after = line.substring(result.col - 1 + result.raw.length);
                    logger = result.severity === 'error' ? loggerError : loggerWarning;
                    out.push("<" + markuplint + "> " + logger(result.severity + ": " + result.message + " (" + result.ruleId + ") " + cli_color_1.default.underline(targetPath + ":" + result.line + ":" + result.col)));
                    if (result.line - 1 > 0) {
                        out.push("  " + cli_color_1.default.cyan(p(result.line - 1, sizes.col, true)) + ": " + space(prev));
                    }
                    out.push("  " + cli_color_1.default.cyan(p(result.line, sizes.col, true)) + ": " + space(before) + cli_color_1.default.bgRed(result.raw) + space(after));
                    if (!config.color) {
                        out.push("         " + invisibleSpace(before) + '^'.repeat(result.raw.length) + invisibleSpace(after));
                    }
                    out.push("  " + cli_color_1.default.cyan(p(result.line + 1, sizes.col, true)) + ": " + space(next));
                }
            }
            else if (!config.problemOnly) {
                out.push("<" + markuplint + "> " + cli_color_1.default.green('passed') + " " + cli_color_1.default.underline(targetPath));
            }
            if (!config.noStdOut && out.length) {
                outs = out.join('\n') + "\n";
                process.stdout.write(config.color ? outs : strip_ansi_1.default(outs));
            }
            return [2 /*return*/, config.color ? out : out.map(strip_ansi_1.default)];
        });
    });
}
exports.standardReporter = standardReporter;
function simpleReporter(targetPath, results, rawSource, options) {
    return __awaiter(this, void 0, void 0, function () {
        var config, sizes, _i, results_3, result, out, _a, results_4, result, s, outs;
        return __generator(this, function (_b) {
            config = Object.assign({}, defaultConfig, options);
            if (!url_1.default.parse(targetPath).host) {
                targetPath = path_1.default.resolve(targetPath);
            }
            sizes = {
                line: 0,
                col: 0,
                meg: 0,
            };
            for (_i = 0, results_3 = results; _i < results_3.length; _i++) {
                result = results_3[_i];
                sizes.line = Math.max(sizes.line, result.line.toString(10).length);
                sizes.col = Math.max(sizes.col, result.col.toString(10).length);
                sizes.meg = Math.max(sizes.meg, w(result.message));
            }
            out = [];
            if (results.length) {
                out.push("<" + markuplint + "> " + cli_color_1.default.underline(targetPath) + ": " + cli_color_1.default.red('✗'));
                for (_a = 0, results_4 = results; _a < results_4.length; _a++) {
                    result = results_4[_a];
                    s = result.severity === 'error' ? '❌' : '⚠️';
                    out.push("  " + cli_color_1.default.cyan(p(result.line, sizes.line, true) + ":" + p(result.col, sizes.col)) + " " + s + "  " + p(result.message, sizes.meg) + " " + cli_color_1.default.xterm(8)(result.ruleId) + " ");
                }
            }
            else if (!config.problemOnly) {
                out.push("<" + markuplint + "> " + cli_color_1.default.underline(targetPath) + ": " + cli_color_1.default.green('✓'));
            }
            if (!config.noStdOut && out.length) {
                outs = out.join('\n') + "\n";
                process.stdout.write(config.color ? outs : strip_ansi_1.default(outs));
            }
            return [2 /*return*/, config.color ? out : out.map(strip_ansi_1.default)];
        });
    });
}
exports.simpleReporter = simpleReporter;
function p(s, pad, start) {
    if (start === void 0) { start = false; }
    var l = w(("" + s).trim());
    var d = pad - l;
    var _ = ' '.repeat(d < 0 ? 0 : d);
    return start ? "" + _ + s : "" + s + _;
}
function w(s) {
    return s.replace(/./g, function (_) { return '0'.repeat(eaw.characterLength(_)); }).length;
}
function space(str) {
    return str
        .replace(/\s+/g, function ($0) {
        return cli_color_1.default.xterm(8)($0);
    })
        .replace(/ /g, function ($0) { return '•'; })
        .replace(/\t/g, function ($0) { return '→   '; });
}
function invisibleSpace(str) {
    return str.replace(/\t/g, function ($0) { return '    '; }).replace(/./g, function ($0) { return ' '; });
}
